Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 4901)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 1)
@@ -1438,22 +484,13 @@
 !
 !--    2d-data output (cross-sections)
-       IF ( time_do2d_xy >= dt_do2d_xy  .AND.  time_since_reference_point >= skip_time_do2d_xy )  THEN
-          IF ( current_timestep_number > timestep_number_at_prev_calc )                            &
-             CALL doq_calculate
-
+       IF ( time_do2d_xy >= dt_do2d_xy )  THEN
           CALL data_output_2d( 'xy', 0 )
           time_do2d_xy = MOD( time_do2d_xy, MAX( dt_do2d_xy, dt_3d ) )
        ENDIF
-       IF ( time_do2d_xz >= dt_do2d_xz  .AND.  time_since_reference_point >= skip_time_do2d_xz )  THEN
-          IF ( current_timestep_number > timestep_number_at_prev_calc )                            &
-
-             CALL doq_calculate
+       IF ( time_do2d_xz >= dt_do2d_xz )  THEN
           CALL data_output_2d( 'xz', 0 )
           time_do2d_xz = MOD( time_do2d_xz, MAX( dt_do2d_xz, dt_3d ) )
        ENDIF
-       IF ( time_do2d_yz >= dt_do2d_yz  .AND.  time_since_reference_point >= skip_time_do2d_yz )  THEN
-          IF ( current_timestep_number > timestep_number_at_prev_calc )                            &
-             CALL doq_calculate
-
+       IF ( time_do2d_yz >= dt_do2d_yz )  THEN
           CALL data_output_2d( 'yz', 0 )
           time_do2d_yz = MOD( time_do2d_yz, MAX( dt_do2d_yz, dt_3d ) )
@@ -1462,8 +499,5 @@
 !
 !--    3d-data output (volume data)
-       IF ( time_do3d >= dt_do3d  .AND.  time_since_reference_point >= skip_time_do3d )  THEN
-          IF ( current_timestep_number > timestep_number_at_prev_calc )                            &
-             CALL doq_calculate
-
+       IF ( time_do3d >= dt_do3d )  THEN
           CALL data_output_3d( 0 )
           time_do3d = MOD( time_do3d, MAX( dt_do3d, dt_3d ) )
@@ -1471,142 +505,51 @@
 
 !
-!--    Masked data output
-       DO  mid = 1, masks
-          IF ( time_domask(mid) >= dt_domask(mid)                                                  &
-               .AND.  time_since_reference_point >= skip_time_domask(mid) )  THEN
-             IF ( current_timestep_number > timestep_number_at_prev_calc )                         &
-                CALL doq_calculate
-
-             CALL data_output_mask( 0, mid )
-             time_domask(mid) = MOD( time_domask(mid), MAX( dt_domask(mid), dt_3d ) )
-          ENDIF
-       ENDDO
-
-!
-!--    Output of time-averaged 2d/3d/masked data
-       IF ( time_do_av >= dt_data_output_av                                                        &
-            .AND.  time_since_reference_point >= skip_time_data_output_av )  THEN
+!--    Output of time-averaged 2d/3d-data
+       IF ( time_do_av >= dt_data_output_av )  THEN
           CALL average_3d_data
-!
-!--       Udate thermal comfort indices based on updated averaged input
-          IF ( biometeorology  .AND.  thermal_comfort )  THEN
-             CALL bio_calculate_thermal_index_maps ( .TRUE. )
-          ENDIF
           CALL data_output_2d( 'xy', 1 )
           CALL data_output_2d( 'xz', 1 )
           CALL data_output_2d( 'yz', 1 )
           CALL data_output_3d( 1 )
-          DO  mid = 1, masks
-             CALL data_output_mask( 1, mid )
-          ENDDO
           time_do_av = MOD( time_do_av, MAX( dt_data_output_av, dt_3d ) )
        ENDIF
-!
-!--    Output of surface data, instantaneous and averaged data
-       IF ( surface_output )  THEN
-          IF ( time_dosurf >= dt_dosurf  .AND.  time_since_reference_point >= skip_time_dosurf )  THEN
-             CALL surface_data_output( 0 )
-             time_dosurf = MOD( time_dosurf, MAX( dt_dosurf, dt_3d ) )
-          ENDIF
-          IF ( time_dosurf_av >= dt_dosurf_av  .AND.  time_since_reference_point >= skip_time_dosurf_av )  THEN
-             CALL surface_data_output( 1 )
-             time_dosurf_av = MOD( time_dosurf_av, MAX( dt_dosurf_av, dt_3d ) )
-          ENDIF
-       ENDIF
 
 !
 !--    Output of particle time series
-       IF ( particle_advection )  THEN
-          IF ( time_dopts >= dt_dopts  .OR.                                                        &
-               ( time_since_reference_point >= particle_advection_start  .AND.                     &
-                 first_call_lpm ) )  THEN
-             CALL lpm_data_output_ptseries
-             time_dopts = MOD( time_dopts, MAX( dt_dopts, dt_3d ) )
-          ENDIF
-       ENDIF
-
-!
-!--    If required, set the heat flux for the next time step to a random value
-       IF ( constant_heatflux  .AND.  random_heatflux )  THEN
-          IF ( surf_def_h(0)%ns >= 1 )  THEN
-             CALL cpu_log( log_point(23), 'disturb_heatflux', 'start' )
-             CALL disturb_heatflux( surf_def_h(0) )
-             CALL cpu_log( log_point(23), 'disturb_heatflux', 'stop' )
-          ENDIF
-          IF ( surf_lsm_h(0)%ns >= 1 )  THEN
-             CALL cpu_log( log_point(23), 'disturb_heatflux', 'start' )
-             CALL disturb_heatflux( surf_lsm_h(0) )
-             CALL cpu_log( log_point(23), 'disturb_heatflux', 'stop' )
-          ENDIF
-          IF ( surf_usm_h(0)%ns >= 1 )  THEN
-             CALL cpu_log( log_point(23), 'disturb_heatflux', 'start' )
-             CALL disturb_heatflux( surf_usm_h(0) )
-             CALL cpu_log( log_point(23), 'disturb_heatflux', 'stop' )
-          ENDIF
-       ENDIF
-
-!
-!--    Execute alle other module actions routunes
-       CALL module_interface_actions( 'after_timestep' )
-
-!
-!--    Determine size of next time step. Save timestep dt_3d because it is
-!--    newly calculated in routine timestep, but required further below for
-!--    steering the run control output interval
-       dt_3d_old = dt_3d
-       CALL timestep
-
-#if defined( __parallel )
-!
-!--    Synchronize the timestep in case of nested run.
-       IF ( nested_run )  THEN
-!
-!--       Synchronize by unifying the time step.
-!--       Global minimum of all time-steps is used for all.
-          CALL pmci_synchronize
-       ENDIF
+       IF ( time_dopts >= dt_dopts  .OR. &
+            ( simulated_time >= particle_advection_start  .AND. &
+              first_call_advec_particles ) )  THEN
+          CALL data_output_ptseries
+          time_dopts = MOD( time_dopts, MAX( dt_dopts, dt_3d ) )
+       ENDIF
+
+!
+!--    Output of dvrp-graphics (isosurface, particles, slicer)
+#if defined( __dvrp_graphics )
+       CALL DVRP_LOG_EVENT( -2, current_timestep_number-1 )
 #endif
-
-!
-!--    Computation and output of run control parameters.
-!--    This is also done whenever perturbations have been imposed
-       IF ( time_run_control >= dt_run_control  .OR.                                               &
-            timestep_scheme(1:5) /= 'runge'  .OR.  disturbance_created )                           &
-       THEN
-          CALL run_control
-          IF ( time_run_control >= dt_run_control )  THEN
-             time_run_control = MOD( time_run_control, MAX( dt_run_control, dt_3d_old ) )
-          ENDIF
-       ENDIF
-
-!
-!--    Output elapsed simulated time in form of a progress bar on stdout
-       IF ( myid == 0 )  CALL output_progress_bar
-
-       IF ( debug_output_timestep )  THEN
-           WRITE( debug_string, * ) 'time_integration', simulated_time
-           CALL debug_message( debug_string, 'end' )
-       ENDIF
+       IF ( time_dvrp >= dt_dvrp )  THEN
+          CALL data_output_dvrp
+          time_dvrp = MOD( time_dvrp, MAX( dt_dvrp, dt_3d ) )
+       ENDIF
+#if defined( __dvrp_graphics )
+       CALL DVRP_LOG_EVENT( 2, current_timestep_number )
+#endif
+
+!
+!--    If required, set the heat flux for the next time step at a random value
+       IF ( constant_heatflux  .AND.  random_heatflux )  CALL disturb_heatflux
+
+!
+!--    Execute user-defined actions
+       CALL user_actions( 'after_timestep' )
 
        CALL cpu_log( log_point_s(10), 'timesteps', 'stop' )
 
-
     ENDDO   ! time loop
 
-#if defined( _OPENACC )
-    CALL exit_surface_arrays
+#if defined( __dvrp_graphics )
+    CALL DVRP_LOG_EVENT( -2, current_timestep_number )
 #endif
-!$ACC END DATA
-!$ACC END DATA
-!$ACC END DATA
-!$ACC END DATA
-!$ACC END DATA
-!$ACC END DATA
-!$ACC END DATA
-!$ACC END DATA
-
-    IF ( myid == 0 )  CALL finish_progress_bar
-
-    CALL location_message( 'atmosphere (and/or ocean) time-stepping', 'finished' )
 
  END SUBROUTINE time_integration
Index: palm/trunk/SOURCE/time_to_string.f90
===================================================================
--- palm/trunk/SOURCE/time_to_string.f90	(revision 4901)
+++ palm/trunk/SOURCE/time_to_string.f90	(revision 1)
@@ -1,36 +1,17 @@
-!> @file time_to_string.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------------------------!
-!
-!
-! Current revisions:
+ FUNCTION time_to_string( time )
+
+!-------------------------------------------------------------------------------!
+! Actual revisions:
 ! -----------------
 ! 
-! 
+!
 ! Former revisions:
 ! -----------------
-! $Id$
-! File re-formatted to follow the PALM coding standard
+! $Log: time_to_string.f90,v $
+! Revision 1.3  2001/01/22 08:16:04  raasch
+! Comments translated into English
 !
-!
-! 4360 2020-01-07 11:25:50Z suehring
-! Corrected "Former revisions" section
-!
-! 3655 2019-01-07 16:51:22Z knoop
-! Corrected "Former revisions" section
+! Revision 1.2  1998/03/09 16:24:53  raasch
+! Dreistellige Stundenausgabe ermoeglicht
 !
 ! Revision 1.1  1997/08/11 06:26:08  raasch
@@ -40,27 +21,18 @@
 ! Description:
 ! ------------
-!> Transforming the time from real to character-string hh:mm:ss
-!--------------------------------------------------------------------------------------------------!
- FUNCTION time_to_string( time )
-
-
-    USE kinds
+! Transforming the time from real to character-string hh:mm:ss
+!-------------------------------------------------------------------------------!
 
     IMPLICIT NONE
 
-    CHARACTER(LEN=9) ::  time_to_string  !<
-
-    INTEGER(iwp)     ::  hours    !<
-    INTEGER(iwp)     ::  minutes  !<
-    INTEGER(iwp)     ::  seconds  !<
-
-    REAL(wp)         ::  rest_time  !<
-    REAL(wp)         ::  time       !<
+    CHARACTER (LEN=9) ::  time_to_string
+    INTEGER           ::  hours, minutes, seconds
+    REAL              ::  rest_time, time
 
 !
 !-- Calculate the number of hours, minutes, and seconds
-    hours     = INT( time / 3600.0_wp )
-    rest_time = time - hours * 3600_wp
-    minutes   = INT( rest_time / 60.0_wp )
+    hours     = INT( time / 3600.0 )
+    rest_time = time - hours * 3600
+    minutes   = INT( rest_time / 60.0 )
     seconds   = rest_time - minutes * 60
 
@@ -68,7 +40,9 @@
 !-- Build the string
     IF ( hours < 100 )  THEN
-       WRITE (time_to_string,'(I2.2,'':'',I2.2,'':'',I2.2)')  hours, minutes, seconds
+       WRITE (time_to_string,'(I2.2,'':'',I2.2,'':'',I2.2)')  hours, minutes, &
+                                                              seconds
     ELSE
-       WRITE (time_to_string,'(I3.3,'':'',I2.2,'':'',I2.2)')  hours, minutes, seconds
+       WRITE (time_to_string,'(I3.3,'':'',I2.2,'':'',I2.2)')  hours, minutes, &
+                                                              seconds
     ENDIF
 
